from pybasicDTW.dtw import DTW
import numpy as np
from types import LambdaType
from typing import Tuple

class Classical(DTW):
    def __init__(self, x:np.ndarray, y:np.ndarray, dimWeights = np.array([]), metric:LambdaType = lambda x,y: np.square(x-y) ,stepPattern:np.ndarray = np.array([(1,1),(1,0),(0,1)]), stepWeights:np.ndarray = np.array([])) -> None:
        # Initalise DTW
        super().__init__(metric= metric, stepPattern=stepPattern, stepWeights=stepWeights)
        # Calculate cost matrix
        self.__ACost, self.__LCost = self.CostMatrix(x=x, y=y, dimWeights=dimWeights, subsequence=False)
        # calculate optimal path
        self.__path, self.__totalCost = self.OptimalWarpingPath(self.__ACost, self.__LCost)
    
    @property
    def AccumulatedCost(self):
        return self.__ACost

    @property
    def LocalCost(self):
        return self.__LCost
    
    @property
    def Path(self):
        return self.__path

    @property
    def TotalCost(self):
        return self.__totalCost